import { Type } from '@angular/core';
import {
  Selector,
  createSelector,
  combineReducers,
  compose
} from '@ngrx/store';

import * as ConfigStore from './config';
import * as RequestStore from './request';


export interface State {
  config: ConfigStore.State;
  request: RequestStore.State;
}

export const EFFECTS: Type<any>[] = [
  ConfigStore.ConfigEffects,
  RequestStore.RequestEffects,
];

export function reducer(state: any, action: any) {
  return combineReducers({
    config: ConfigStore.reducer,
    request: RequestStore.reducer,
  })(state, action);
}

// export const REDUCER = combineReducers({
//   config: ConfigStore.reducer,
//   request: RequestStore.reducer,
// });

export function getSelectors<S>(selector: Selector<any, State>) {
  return {
    ConfigSelector: ConfigStore.getSelectors(createSelector(
      selector,
      (state: State) => state.config,
    )),
    RequestSelector: RequestStore.getSelectors(createSelector(
      selector,
      (state: State) => state.request,
    )),
  };
}
