import { Type } from '@angular/core';
import {
  Selector,
  createSelector,
  combineReducers,
  compose
} from '@ngrx/store';

import * as InfraStore from './infra';


export interface State {
  infra: InfraStore.State;
}

export const EFFECTS: Type<any>[] = [
  InfraStore.InfraEffects,
];

export function reducer(state: any, action: any) {
  return combineReducers({
    infra: InfraStore.reducer,
  })(state, action);
}

// export const REDUCER = combineReducers({
//   infra: InfraStore.reducer,
// });

export function getSelectors<S>(selector: Selector<any, State>) {
  return {
    InfraSelector: InfraStore.getSelectors(createSelector(
      selector,
      (state: State) => state.infra,
    )),
  };
}
